﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Input

Public Class frmMain

    '初期化
    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        Dim i As Integer
        Dim work_str_arr(32) As String

        Dim currentState As GamePadState = GamePad.GetState(PlayerIndex.One)

        If currentState.IsConnected = False Then
            MessageBox.Show("Controller is not connected")
            End
        End If

        Values.inits()
        Timer1.Enabled = True

        work_str_arr = IO.Ports.SerialPort.GetPortNames
        For i = 0 To work_str_arr.Length - 1
            comboSIO1.Items.Add(work_str_arr(i))
        Next

    End Sub

    Private Sub btnComswitch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnComswitch.Click
        Dim response As MsgBoxResult
        Dim buff(64) As Byte

        'ポートが既に開かれているかチェック
        If Me.SerialPort1.IsOpen = False Then
            Try
                'タイマーストップ（ジョイパッド表示用）
                Me.Timer1.Enabled = False
                'ポートオープン
                Me.SerialPort1.PortName = comboSIO1.Text
                Me.SerialPort1.Open()
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポート" + Me.SerialPort1.PortName + "のオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            Catch ex As UnauthorizedAccessException
                response = MsgBox("エラー！シリアルポート" + Me.SerialPort1.PortName + "のオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            End Try
            If Me.SerialPort1.IsOpen = True Then
                'ボタンの色を動作中色に変更
                Me.btnComswitch.BackColor = Values.active_button_color
            End If
        Else
            Try
                'ポートクローズ
                Me.SerialPort1.Close()
                'タイマースタート（ジョイパッド表示用）
                Me.Timer1.Enabled = True
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポートのクローズに失敗しました。", MsgBoxStyle.Information)
            End Try
            If Me.SerialPort1.IsOpen = False Then
                'ボタンの色をフォームの背景色に変更
                Me.btnComswitch.BackColor = Values.org_back_color
            End If
        End If
    End Sub

    'シリアルポートを開いていない状態で行う確認用（タイマー動作）
    Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
        Dim status, LX, LY, arm_dx, arm_dy, arm_dz As Single

        Values.joypad_status1 = Values.joypad_status0
        clPadStatus.getcmd(status, LX, LY, arm_dx, arm_dy, arm_dz)
        Values.joypad_status0 = status

        '２回以上続けて送信しないキーの処理（一歩動いて止まる場合）
        If Values.joypad_status0 = Values.joypad_status1 And Values.joypad_status0 >= 9 And _
            Values.joypad_status0 <= 12 Then
            txtMessages.Text = "000" + vbCrLf
        Else
            txtMessages.Text = Format(Values.joypad_status0) + vbCrLf
        End If

        lblLX.Text = LX.ToString
        lblLY.Text = LY.ToString

        lblArm_dx.Text = arm_dx.ToString
        lblArm_dy.Text = arm_dy.ToString
        lblArm_dz.Text = arm_dz.ToString

    End Sub

    Private Sub btnEnd_Click(sender As System.Object, e As System.EventArgs) Handles btnEnd.Click
        End
    End Sub

    Private Sub SerialPort1_DataReceived(sender As Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        '変数定義
        Dim command_char(64), buff(64) As Byte
        Dim LX, LY, arm_dx, arm_dy, arm_dz As Single
        Dim i As Integer

        Do
            'timing loop
            System.Windows.Forms.Application.DoEvents()
        Loop While Me.SerialPort1.BytesToRead < 1

        Me.SerialPort1.Read(buff, 0, 1)

        If buff(0) = Asc("A") Then

            Values.joypad_status2 = Values.joypad_status1
            Values.joypad_status1 = Values.joypad_status0
            clPadStatus.getcmd(Values.joypad_status0, LX, LY, arm_dx, arm_dy, arm_dz)
            buff(0) = Values.joypad_status0

            If Values.joypad_status0 = 9 Then buff(0) = 1
            If Values.joypad_status0 = 10 Then buff(0) = 2
            If Values.joypad_status0 = 11 Then buff(0) = 7
            If Values.joypad_status0 = 12 Then buff(0) = 8

            '３回以上続けて送信しないキーの処理（一歩動いて止まる場合）
            If Values.joypad_status0 = Values.joypad_status1 And Values.joypad_status1 = Values.joypad_status2 _
                And Values.joypad_status0 >= 9 And Values.joypad_status0 <= 12 Then
                buff(0) = 0
            End If

            'ボタン情報をシリアルポートから出力
            Me.SerialPort1.Write(buff, 0, 1)

            'If Values.joypad_status0 = 13 Then MsgBox("13")
            'アーム操作
            If Values.joypad_status0 = 99 Then
                System.Threading.Thread.Sleep(2)

                buff(0) = arm_dx
                buff(1) = arm_dy
                buff(2) = arm_dz
                'ボタン情報をシリアルポートから出力
                For i = 0 To 2
                    Me.SerialPort1.Write(buff, i, 1)
                    'System.Threading.Thread.Sleep(1)
                Next

            End If
        End If

    End Sub
End Class
